summaryrefslogtreecommitdiff
path: root/init.d/savecore.in
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
committerRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
commit55eb3794fb4ad563102d5ab30c1d5337a599b2e5 (patch)
tree0d052faeb050c1e18ba56f6f6189bff3ffca28c9 /init.d/savecore.in
parent08aff6ef44ac5dc438d916b53aa61385f6d299f3 (diff)
downloadopenrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.gz
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.bz2
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.xz
Rework our folder structure so that we don't have OS specific dirs, making it easier to share init and conf files per OS.
Diffstat (limited to 'init.d/savecore.in')
-rw-r--r--init.d/savecore.in36
1 files changed, 36 insertions, 0 deletions
diff --git a/init.d/savecore.in b/init.d/savecore.in
new file mode 100644
index 0000000..e23bde4
--- /dev/null
+++ b/init.d/savecore.in
@@ -0,0 +1,36 @@
+#!@PREFIX@/sbin/runscript
+# Copyright 2007-2008 Roy Marples <roy@marples.name>
+# All rights reserved. Released under the 2-clause BSD license.
+
+description="Saves a kernel dump."
+
+depend()
+{
+ need localmount
+ keyword nojail noprefix
+}
+
+start()
+{
+ local dump_dir=${dump_dir:-/var/crash}
+ if ! [ -d "${dump_dir}" ]; then
+ mkdir -p "${dump_dir}"
+ chmod 700 "${dump_dir}"
+ fi
+
+ if [ "${RC_UNAME}" = "FreeBSD" ]; then
+ # Don't quote ${dump_device}, so that if it's unset,
+ # savecore will check on the partitions listed in fstab
+ # without errors in the output
+ savecore -C "${dump_dir}" ${dump_device} >/dev/null
+ else
+ ls "${dump_dir}"/bsd* > /dev/null 2>&1
+ fi
+ [ $? = 0 ] || return 0
+
+ local sopts="${dump_dir} ${dump_device}"
+ yesno ${dump_compress} && sopts="-z ${sopts}"
+ ebegin "Saving kernel core dump in ${dump_dir}"
+ savecore ${sopts} >/dev/null
+ eend $?
+}